2025-05-21 [1.42 Bld 287]

- Bugfix      : Z380: correct encoding of 'add hl,(abs)'
- Bugfix      : Z380: correct encoding of 'ld (sp+disp),r16'
- Bugfix      : Z380: permit 24/32 bit operand for
                'add/sub sp,nnnn'
- Bugfix      : PALM: correct implementation of JMP
                with absolute argument
- Bugfix      : 68K: correct encoding of BFCHG/BFSET/BFCLR
- Bugfix      : 68K: correct encoding MULS.L/MULU.L
- Bugfix      : 68K: correct list of addressing modes for PMOVE <reg>,<ea>
- Bugfix      : 68K: correct PMMU condition encoding
- Bugfix      : 68K: correct offset for PC-relative addressing of PRESTORE
- Bugfix      : 68K: correct allowed addressing modes for PRESTORE
- Bugfix      : 68K: correct operand size handling for PFLUSHR
- Change      : Z380: make DDIR prefix handling more flexible

2025-04-28 [1.42 Bld 286]

- Bugfix      : Correct checksum computation for MOS Hex
                format.
- Bugfix      : Correct encoding of CPU16 BCLRW, BSETW,
                MOVW, and MOVB instructions.
- Bugfix      : Correct range of offsets for CPU16
                MAC/RMAC instructions.

2025-04-26 [1.42 Bld 285]

- Bugfix      : Revert RADIX and OUTRADIX to the documented
                behaviour, i.e. expecting a plain number in
                preferrably decimal, rather than an expression
                in the current radix.
- Bugfix      : Correct #off8(Rp) addressing mode parsing on
                TMS370.

2025-04-21 [1.42 Bld 284]

- Change      : out-of-range displacement for (d16,PC)
                and (d8,PC,Xn) on 68000 is now reported as
                such
- Bugfix      : correct encoding of LD (nnnn),SP on GBZ80
- Addition    : Display values unknown in first pass as
                question mark (may be disabled via command
                line switch): implemented so far for 65xx,
                Zx80, MCS-(2)51 and 8080/8085.

2025-02-09 [1.42 Bld 283]

- Addition    : new target TLCS-42
- Addition    : add IFSYM(N)EXIST statements and SYMEXIST()
                function

2025-01-01 [1.42 Bld 282]

- Addition    : new command line switch '-radix' to set
                default number system
- Addition    : implement built-in JS instruction macro
                for SC/MP
- Addition    : new command line switch '-intsyntax' to
                change default syntax for integer constants

2024-11-20 [1.42 Bld 281]

- Bugfix      : DB/DW on 68xx are big endian again

2024-11-15 [1.42 Bld 280]

- Addition    : DB and DW on 65xx and 68xx targets allow
                both Intel and Motorola style duplication
                of values.
- Addition    : Allow the {EXPAND}, {NOEXPAND}, {EXPIF},
                {NOEXPIF}, {EXPMACRO}, {NOEXPMACRO},
                {EXPREST}, and {NOEXPREST} directives
                also for IRP, IRPC, REPT, and WHILE,

2024-11-09 [1.42 Bld 279]

- Bugfix      : Add missing error message about invalid
                symbol name in some situations.
- Change      : Differentiate negative/positive floating
                point constant overflow.
- Change      : Detect overflow on integer constants,
                and try to treat them as float instead.
- Bugfix      : LONG instruction did not test for 32 bit
                value range.

2024-10-20 [1.42 Bld 278]

- Bugfix      : correct encoding of PDP-11 instructions
                M(F|T)P(D|I)
- Change      : uCOM-43: Issue warning when decision about
                CZP's argument type is unclear
- Change      : Introduce short circuit evaluation for
                logical AND and OR.
- Bugfix      : regard different arguments for LDS/LDD on
                TMS99110 and TI990.

2024-09-29 [1.42 Bld 277]

- Change      : IFDEF, IFNDEF, and DEFINED() also accept an
                expression as argument, not only a simple
                symbol name.  They return true if the
                expression does not contain any symbols
                that are undefined up to now.
- Bugfix      : Add missing PDP-11 instructions STCFD and STCDF.
- Bugfix      : 68K: Assume default operand size of 8 bits also
                for FScc and PScc, not only for Scc.
- Bugfix      : 68K: Allow PC-relative addressing for FRESTORE
                and PRESTORE.

2024-09-15 [1.42 Bld 276]

- Bugfix      : Regard infinities for DC.{SDP}, DD, and DQ
- Bugfix      : ...as a consequence, do not allow 'INF' for
                user-defined symbols
- Bugfix      : ifdef ..., if defined(...), and ifused ...
                did not check for valid symbol names
- Bugfix      : correct entry address printout for PLIST

2024-09-01 [1.42 Bld 275]

- Addition    : P2BIN warns if checksum overwrites data from
                source file(s)
- Bugfix      : uCOM-43: correct behaviour of JCP on last
                address in 64 byte page.

2024-08-25 [1.42 Bld 274]

- Addition    : pre-define variable FLOATMAX
- Addition    : use 80 bit extended float on host platforms
                supporting it

2024-08-05 [1.42 Bld 273]

- Addition    : support NEC uCOM 43/44/45

2024-07-24 [1.42 Bld 272]

- Change      : If the file name given as argument to INCLUDE
                or BINCLUDE does not contain an extension, the
                name extended by .INC and the plain name is
                searched for (in this order).
- Bugfix      : The message "Additional pass not started..."
                is now also added to the summary written
                to the console.
- Change      : Allow MFPT and XOR on T-11 (architecture
                handbook seems to be wrong on this)
- Change      : The DT pseudo instruction stores integer
                arguments in packed BCD format, instead
                of converting integers to floats
- Addition    : support Zilog eZ80

2024-06-26 [1.42 Bld 271]

- Bugfix      : warn about usage of MOV A,ACC on MCS-51
- Bugfix      : disallow odd addresses for CALL #IA on Super8
- Bugfix      : correct operand size of DIVD on 6309
- Bugfix      : correct FMOVE FPcr<->An handling on 68K
- Bugfix      : correct FMOVEM handling of dynamic register
                lists on 68K
- Addition    : add support for register symbols on x86

2024-06-19 [1.42 Bld 270]

- Bugfix      : allow .byte and .word on PDP-11 again.
- Addition    : initial VAX support

2024-04-13 [1.42 Bld 269]

- Addition    : Make per-line header in listing configurable
                via format string

2024-04-03 [1.42 Bld 268]

- Bugfix      : Z80: Do not warn about possible relative jump if
                relative jumping is not allowed for the given
                condition.
- Bugfix      : Z80: Do not warn about possible relative jump if
                the target address's value is questionable.  This
                applies e.g. to forward references in the first
                pass.

2024-03-30 [1.42 Bld 267]

- Addition    : Add new Z80 pseudo instruction 'J' that assembles
                as JR or JP, depending on branch distance.
- Bugfix      : Correct PHASE when handling addresses beyond 2 GByte.
- Addition    : Add a command-line switch '-wrelative' to enable
                warnings about possible relative jump.
- Change      : Rework the indiredt address expression parser for
                the following targets: 80C16x, uCOM78, 8086,
                TLCS-870(C), TLCS-90(0(0)), XA, Z80, Z8000.
                Behaviour *should* be the same as before.

2024-03-25 [1.42 Bld 266]

- Bugfix      : Add missing error message about invalid length
                of multi character constants.
- Bugfix      : Regard questionable forward references for Z80.
- Change      : The default target is now NONE instead of 68008.
                A target has to be set explicitly to generate code.

2024-03-15 [1.42 Bld 265]

- Change      : Learn maximum include level in first pass, so
                include nesting field in listing has fixed length
                in subsequent passes.
- Bugfix      : Correct address range checking for TLCS-900 and Z380.

2024-03-08 [1.42 Bld 264]

- Bugfix      : On Zx80, do not use indexed mode with extended
                displacement if the target is not Z380, even in
                case of a first-pass-unknown symbol.

2024-03-03 [1.42 Bld 263]

- Addition    : Add support for Sharp SC62015/SC61860 (contribution
                by Haruo Asano)

2024-02-11 [1.42 Bld 262]

- Addition    : New command line switch '-underscore-macroargs' to
                allow underscores in macro parameter names
- Change      : No longer allow omission of an empty index argument
                on 6809.  Use 'plainbase on' or '-plainbase' to allow
                this again.
- Bugfix      : 'DS 0' to align program counter did not operate
                correctly on addresses beyond 2 GByte

2024-01-28 [1.42 Bld 261]

- Bugfix      : On Z80-like targets, also do not parse double/triple
                -/+ as indirect expression
- Bugfix      : On NS32K, make parsing of address expressions more
                robust against arguments like '\'' or X'xx

2023-12-31 [1.42 Bld 260]

- Bugfix      : On Z80-like targets, do not parse single -/+ as
                indirect expression
- Bugfix      : If address overflow occured, the code that triggered
                it was displayed anyway in the listing, and with
                a wrong start address.

2023-12-27 [1.42 Bld 259]

- Bugfix      : On 68K, correctly skip spaces in indirect
                addressing argument lists

2023-12-23 [1.42 Bld 258]

- Bugfix      : disallow a few addressing modes for TST on 68K
- Bugfix      : reduce size of icon resource for Windows binaries

2023-12-17 [1.42 Bld 257]

- Change      : On F8, I/O accesses to addresses 0 to 3 via IN or
                OUT now result in a warning, since they are
                only accessible via INS and OUTS.
- Bugfix      : correct several 8087 instructions

2023-12-02 [1.42 Bld 256]

- Bugfix      : TLCS-90(0): Allow arguments of LDA, JP amd CALL to be
                written without enclosing parentheses.
- Addition    : Support register symbols for SC/MP
- Change      : On SC/MP, Usage of -128 as displacement with P1...P3
                emits a warning instead of an error 

2023-11-17 [1.42 Bld 255]

- Bugfix      : SC/MP: Allow PC-relative addressing with displacement
                of -128, but disallow using E.  Likewise, allow E and
                forbid -128 if pointer register is P1...P3.
- Change      : Message source files now have the extension '.mes'
                instead of '.res' to avoid extension conflicts with
                resource files on some systems
- Bugfix      : (Default) endianess for DW, DD,... on NS32K is little endian
- Addition    : Add BIGENDIAN for NS32K

2023-11-04 [1.42 Bld 254]

- Bugfix      : TLCS-9000: correct condition parsing

2023-11-04 [1.42 Bld 253]

- Bugfix      : SC/MP: Allow PC with displacement as address argument,
                as long as no auto-increment is used
- Bugfix      : SC/MP: Check whether PC-relative addressing would result
                in a displacement of -128
- Change      : Incorporate a couple of changes to compile with MSVC,
                provided by Fred N. van Kempen

2023-10-29 [1.42 Bld 252]

- Change      : Add $(EOBJ), $(OOBJ), $(TARG_EOBJ), and $(TARG_OOBJ)
                variables to Makefiles, which may be overridden by
                Makefile.def for non-'UNIX-style' compilers that do
                not use '-o'
- Addition    : 78(C)xx: Implement 'Z80-style' instructions for
                a couple of machine instructions
- Bugfix      : 78(C)xx: Do not accept undefined instructions:
                ADIW, ACIW, ADINCW, SUIW, SBIW, SUINBW
- Bugfix      : MCS-51: flag invalid addressing mode '@DPTR+disp'

2023-10-01 [1.42 Bld 251]

- Bugfix      : IM6100: Operand combination SZL OSR HLT did not work
- Bugfix      : IM6100: Allow combined instructions in lowercase

2023-09-27 [1.42 Bld 250]

- Bugfix      : Setting field length of PC in listing also works
                if target is given via CPU statement in source file

2023-09-25 [1.42 Bld 249]

- Addition    : Allow zero-padded PC in listing by setting a list
                radix with leading zero

2023-09-17 [1.42 Bld 248]

- Change      : Allow values between 0x80 and 0xff on 68K, but warn
                about sign extension
- Bugfix      : Correct encoding of V35 BRKS/BRKN instructions
- Addition    : Add new NEC Vxx variants
- Bugfix      : Add missing JLT, JGT, and JGE instructions for
                TMS7000

2023-07-10 [1.42 Bld 247]

- Change      : No separate .msg files any more for most platforms
- Bugfix      : Several fixes to work with compilers shipped with
                Debian 12 (Bookworm)

2023-05-24 [1.42 Bld 246]

- Change      : The binary's name is now 'asl' on all platforms.
- Bugfix      : Use system-specific path separator when searching
                for suffix

2023-05-14 [1.42 Bld 245]

- Change      : Rework command line output and operation:
                - No interactive query of input files, if none
                  are given via command line.
                - Version information is only printed if verbose
                  operation (-v) or version info (-version) is
                  requested.
                - Verbose help is printed upon request (-help).
                - CPU list is printed if requested via '-cpu list'
                  or '-cpu ?'.
                - paging of CPU list or help is off by default
                  and may be re-enabled by '-screenheight' argument
- Change      : Remove proposal for new program name (for the
                moment)

2023-05-07 [1.42 Bld 244]

- Addition    : Make proposal for new program name
- Addition    : Always allow .SET, .EQU, .PAGE, .SWITCH,
                .SHIFT, .SAVE and .RESTORE as alternatives to
                the 'undotted' instructions, regardless whether
                machine instructions of same name exist.
- Bugfix      : Correct handling of on/off instructions inside
                expanded macros

2023-04-15 [1.42 Bld 243]

- Addition    : Add Renesas RX target (contribution
                by Haruo Asano)
- Bugfix      : WD16: correct format 11 addressing modes
- Bugfix      : PDP-11/WD16: @(Rn) was wrongly assembled as @Rn

2023-04-10 [1.42 Bld 242]

- Change      : Enable more FP16 tests
- Bugfix      : assign unique header ID to PDP-11
- Change      : Multi-character constants are now little endian
                on PDP-11
- Addition    : Add Western Digital WD16 target

2023-04-01 [1.42 Bld 241]

- Bugfix      : Correct displacement value for relative branches
                and PC-relative addressing on PDP-11
- Addition    : Support CALL as alias for JSR on PDP-11 with PC
                as register
- Bugfix      : Correct availibility of MTPS/MFPS on PDP-11 variants
- Bugfix      : Correct 16-bit indexed addressing on Konami 052001
                if index register is not PC

2023-03-27 [1.42 Bld 240]

- Addition    : add Konami 052001 as target

2023-03-08 [1.42 Bld 239]

- Addition    : allow to set BIGENDIAN flag's default value by
                command line
- Addition    : allow to set PACKING flag's default value by
                command line
- Bugfix      : Allow 8 bit AND/OR on H8/300(L)
- Addition    : German documentation may optionally be built
                with Babel-based German style

2023-02-19 [1.42 Bld 238]

- Bugfix      : Extend and correct Code page 037 definition
- Addition    : Support ORB as alias for OR on PALM
- Addition    : Add definition of IBM 5110's variant of EBCDIC
- Addition    : Add character set definition for IBM 5100
- Addition    : JMP on PALM encodes as BRA if possible
- Addition    : CHARSET allows characters to be defined
                'non-existant' on the target system
- Addition    : Allow alternative conditions P/N/Z on 2650,
                plus numeric conditions
- Addition    : Add ACON and RES instructions on 2650
- Addition    : Optionally allow A'...' syntax for multi
                character constants.
- Addition    : Support BIGENDIAN on 2650 to control
                behaviour of DW, DD, DQ...
- Bugfix      : JMP on PALM now also supports auto-increment
                and -decrement

2023-02-05 [1.42 Bld 237]

- Addition    : Add National Semiconductor IMP-16 and PACE targets

2023-01-18 [1.42 Bld 236]

- Addition    : Add Rockwell PPS-4 target
- Addition    : Add DCM statement to 6502 to dispose
                floating point constants in Apple format

2022-12-31 [1.42 Bld 235]

- Addition    : Add AEG/Olympia CP-3F target
- Change      : Reworked symbol table handling to make it
                slightly faster

2022-12-21 [1.42 Bld 234]

- Addition    : Allow DB as alias for BYT on 65xx
- Addition    : Allow DW as alias for ADR on 65xx
- Addition    : Allow DS as alias for RMB on 65xx
- Addition    : Add DDB for 65xx and MELPS-7700

2022-12-05 [1.42 Bld 233]

- Bugfix      : Correct encoding of SP register alias on SH
- Bugfix      : Add missing comparison operators for register symbols
- Addition    : Allow != as unequality operator
- Bugfix      : addr(ireg) was correctly encoded as PC-relative on V60,
                but without encoding a possible index register

2022-11-01 [1.42 Bld 232]

- Addition    : Add translation of non-printable ASCII control characters
                to EBCDIC code page
- Addition    : Add BCDINC (code page 359)
- Addition    : Add RADIX 50 code page and packing macro
- Addition    : Add CODEPAGE_VAL function to query mapping of a
                single character
- Bugfix      : DC.x on V60 gets correct operand size, uses little
                endian and does not pad by default
- Bugfix      : V60: plain address as address operand is treated as
                PC-relative instead of being silently ignored

2022-10-23 [1.42 Bld 231]

- Addition    : Add IBM PALM target

2022-10-03 [1.42 Bld 230]

- Addition    : Add DEC PDP-11 target

2022-08-24 [1.42 Bld 229]

- Addition    : Add NEC V60 target

2022-08-03 [1.42 Bld 228]

- Addition    : Add Intersil IM6100/6120 target (contribution
                by Haruo Asano)

2022-07-17 [1.42 Bld 227, the Asano & Tadaoka build ;-) ]

- Bugfix      : re-initialize radix & outradix base at every
                pass
- Bugfix      : assemble LODZ R0 as IORZ R0 on 2650
- Bugfix      : explicitly disallow STRZ R0 on 2650
- Bugfix      : regard 8K modulo arithmetic for relative addressing on 2650
- Change      : Allow 32K (4*8K) address space on 2650
- Bugfix      : Add missing V30 BRKEM instruction
- Addition    : Add V30EMU target as variant of 8080 with
                CALLN and RETEM instructions

2022-07-13  [1.42 Bld 226]

- Bugfix      : Correct argument separator for DSP56K (Tab)
- Bugfix      : If line continuation is used, use the line
                number of the first line, not the last one

2022-07-09  [1.42 Bld 225]

- Addition    : Add HP Nano Processor target (contribution by Haruo Asano)
- Change      : No longer provide manual as PostScript (may be generated
                from PDF version or from doc_*/as.pdf target).

2022-07-03  [1.42 Bld 224]

- Addition    : Support PACKING for 56000, TMS320C3x/4x, TMS32060, 
                uPD7720/7725, and uPD77230
- Bugfix      : DATA on uPD7720/7725 in packed mode behaves the same
                way as DW for uPD77230, i.e. characters are filled in
                from left to right into words
- Bugfix      : Correct INS/EXT on V30 with immediate operand
- Bugfix      : On V30, allow CY as operand to NOT1/CLR1/SET1

2022-06-15 [1.42 Bld 223]

- Addition    : Support PACKING for MN1610 (contribution by Haruo Asano)
                and CP1600 (contribution by Kasumi Yoshino)
- Addition    : Support floating point constants for MN1610 (contribution by Haruo Asano)
- Addition    : 68HC11K4: ASSUME may be informed about the values
                of CONFIG, INIT and INIT2 registers
- Addition    : Z180: Value of CBAR, CBR, and BBR may be specified
                via ASSUME, to define the 64K -> 512K address mapping

2022-03-16 [1.42 Bld 222]

- Bugfix      : -supmode command line switch works again
- Bugfix      : Z8000: correct register overlap check for PUSH/POP

2022-03-12 [1.42 Bld 221]

- Bugfix      : 68K: allow k factor to FMOVE on dest operand

2022-02-13 [1.42 Bld 220]

- Bugfix      : correct MCS-96 RST instruction (was 'RSC' instead)
- Change      : MCS-96: change a few 32 bit operand alignment warnings
                to errors, to make consistent with 16 bit alignment
                errors

2022-02-09 [1.42 Bld 219]

- Bugfix      : Symbols without assigned address space did not appear
                in MAP file

2022-02-02 [1.42 Bld 218]

- Addition    : add DEFBIT for uPD7807...7809
- Change      : A couple of target-specific symbols now only appear
                in the symbol table if the respective target was
                actually used

2022-01-30 [1.42 Bld 217]

- Bugfix      : 2650: do not allow ANDZ R0 (decodes as HALT)
- Bugfix      : uPD780x: disallow some uPD781x-specific addressing modes
                for LDAX and STAX
- Addition    : support NEC uPD7807...7809
- Bugfix      : Do not attempt to expand string expansion for symbol
                names in quoted regions
- Bugfix      : The default for PADDING for 6805, 6809, 6816, 68RS08,
                and S12Z should be OFF

2022-01-19 [1.42 Bld 216]

- Bugfix      : Z80: add error messages about address/displacement
                overflow that got lost during address parser rework

2021-12-26 [1.42 Bld 215]

- Bugfix      : Z80: Allow register symbols for JP (IX/IY), forbid
                on Gameboy Z80

2021-12-23 [1.42 Bld 214]

- Addition    : Add some syntax variants for Sharp SM83
- Addition    : Allow SLI/SL1 as alias for SLIA/SLS on Z80UNDOC
- Addition    : Allow EXA as alias for EX AF,AF' on Z80
- Addition    : Allow EXD as alias for EX DE,HL on Z80
- Addition    : For undocumented Z80 instructions with extra
                destination reg, allow dest reg to be last arg
                instead of first
- Addition    : Allow register symbols for Z80

2021-11-22 [1.42 Bld 213]

- Bugfix      : Correct TMS1100 XMA instruction
- Addition    : Add Sharp LR35902 ('Gameboy Z80') as target
- Bugfix      : Allow (X0)/(X1) as argument on MN1613 LR
- Bugfix      : Allow lowercase register names  on MN1613 LR

2021-11-03 [1.42 Bld 212]

- Bugfix      : Do not print empty file name () on listing pages with symbol tables
- Addition    : Add CP-1600 target (contribution by Haruo Asano)

2021-10-03 [1.42 Bld 211]

- Bugfix      : Allow register aliases starting with period in 68K address expressions

2021-09-28 [1.42 Bld 210]

- Bugfix      : Regard Address-Shift instructions with single argument on TMS3201x
- Bugfix      : Be more tolerant about leading/trailing spaces in indirect address
                expressions on 68K

2021-09-19 [1.42 Bld 209]

- Addition    : Add built-in IN/OUT symbols PA0..PA7 for TMS3201x

2021-09-13 [1.42 Bld 208]

- Addition    : Add support for NEC uCOM87 (uPD780x)

2021-07-26 [1.42 Bld 207]

- Bugfix      : NS32K: allow immediate destination operand for CMPf

2021-07-25 [1.42 Bld 206]

- Bugfix      : NS32K: allow immediate destination operand for CMPQi
- Bugfix      : correct address output for Intel32 Hex format

2021-07-03 [1.42 Bld 205]

- Bugfix      : correct encoding and allowed addressing modes of XCH(B) on MCS-96
- Change      : huge internal rework to allow strings longer than 255 characters
                at some (but far off from all...) places

2021-05-08 [1.42 Bld 204]

- Bugfix      : fix SC/MP target

2021-05-07 [1.42 Bld 203]

- Addition    : Allow changing the program counter by assigning value to PC
                symbol
- Addition    : Allow BIGENDIAN for SC/MP
- Bugfix      : Several bugfixes if host system is big-endian

2021-04-25 [1.42 Bld 202]

- Change      : Somewhat less unintuitive error message if source file cannot
                be opened
- Bugfix      : Better handling of DUP operator in DB, DW, DD... if there is
                also a symbol of this name
- Addition    : Add file name to all error messages when file open fails

2021-04-17 [1.42 Bld 201]

- Bugfix      : fix MSP430X MOVA instruction with 0(Rn) or @Rn as destination
- Change      : Logic to update label's value in case of implicit padding gets
                reset by less pseudo instructions

2021-03-28 [1.42 Bld 200]

- Addition    : Add NS32K custom processor instructions
- Addition    : Add NS32K floating point register names Lx
- Bugfix      : repair -D <var>=<value> option

2021-03-19 [1.42 Bld 199]

- Bugfix      : Correct address of NS32082 BPR1 register 
- Bugfix      : Correct operand size handling of NS32xxx MOVLF/MOVFL
- Bugfix      : Correct operand size of NS32xxx shift/rotate instructions
- Addition    : Allow addr(pc) as syntax for NS32xxx PC-relative addressing
- Addition    : Allow disp2(disp1(ext)) as syntax variant for NS32xxx
                external mode

2021-03-17 [1.42 Bld 198]

- Bugfix      : Some cleanups regarding Z180 I/O instructions
- Addition    : PMMU instruction on NS32000 allows differentiation
                of MMU variants
- Bugfix      : NS32000: Correct addressing modes of INDEXi and CVTP
- Bugfix      : NS32000: Correct EXT addressing mode

2021-03-14 [1.42 Bld 197]

- Addition    : Support NS32000 as target

2021-03-02 [1.42 Bld 196]

- Bugfix      : Correct ADDQ/SUBQ range checking for 68K

2021-02-18 [1.42 Bld 195]

- Bugfix      : Avoid identifying 0B....H as C-style binary in relaxed mode
- Bugfix      : correct indexed addressing mode with short base for Z8000

2021-02-15 [1.42 Bld 194]

- Bugfix      : fix SAVE/RESTORE instructions
- Addition    : add J... variable branch instructions for 180x

2021-02-13 [1.42 Bld 193]

- Addition    : add more flexible integer format configuration
- Addition    : add PORT statement for 8008
- Addition    : add Z80SYNTAX for 8008

2021-01-30 [1.42 Bld 192]

- Addition    : Initial support for Padauk controllers
- Bugfix      : fix ST6 ASCII/ASCIZ instructions

2021-01-21 [1.42 Bld 191]

- Addition    : SC/MP: allow writing registers as 0..3 instead of P0..P3
- Addition    : SC/MP: add x'... notation option for integer literals
- Bugfix      : correct NoICE debug output
- Bugfix      : corect cross reference list output

2021-01-18 [1.42 Bld 190]

- Bugfix      : emit more reasonable error message when trying to
                convert multi-character constant resp. string of
                excessive length to integer
- Addition    : Z8000 Syntax extensions:
                - Add a few aliases for conditions
                - Add a few aliases for flag names
                - Allow Rn^ instead of @Rn for indirect addressing
                - for alternate (AMD) syntax, allow leaving away
                  indirection character for indirectly addressed I/O
- Bugfix      : repair NoICE debug output
- Addition    : add -supmode switch to enable supervisor mode
                right from the beginning

2021-01-10 [1.42 Bld 189]

- Bugfix      : correct encoding of Z8000 CALR instruction
- Bugfix      : string expansion was not done for names of structure
                elements
- Bugfix      : correct inclusion of bit symbols in nested structures
- Addition    : extend list of supported F8 variants
- Addition    : add option to define arrays of structures

2020-12-27 [1.42 Bld 188]

- Bugfix      : correct encoding of Z8000 EI/DI instruction
- Addition    : Add F3850 as target (contribution by Haruo Asano)
- Bugfix      : do not display line numbers in split byte notation

2020-12-25 [1.42 Bld 187]

- Bugfix      : add a couple of missing instructions and
                instruction/operand combinations to Z8000 target

2020-12-21 [1.42 Bld 186]

- Addition    : add -q(uiet) command line switch to PLIST and support
                multiple files
- Addition    : Support Z8000 as target
- Addition    : add -splitbyte command line switch

2020-12-09 [1.42 Bld 185]

- Addition    : Add compatibility mode switch for better compatibility
                with original assemblers on certain targets

2020-12-08 [1.42 Bld 184]

- Change      : Output generated by MESSAGE to console is suppressed
                in quiet mode
- Addition    : Add configurable maximum include nesting level
- Addition    : add -q(uiet) command line switch to P2BIN and P2HEX
- Change      : 'make test' now runs in quiet mode on *IX systems, set V=1
                to get verbose output back
- Addition    : Optimize SUB #(-2...+2),... to ADD:Q only if Q format requested

2020-12-03 [1.42 Bld 183]

- Bugfix      : Disallow optimzation to CoMPare 8-bit immediate value with
                16-bit operand on H8/500

2020-11-26 [1.42 Bld 182]

- Bugfix      : Better treatment of (mis)detection of non-octal constants
                in relaxed mode
- Bugfix      : If whole instruction has dot prefix, still search for
                attribute in it

2020-11-25 [1.42 Bld 181]

- Addition    : Support :8 and :16 instruction formats for branches on H8/500
- Bugfix      : Some fixes to H'xxxx hex syntax on H8/500 and H8/300
- Bugfix      : correct TLCS-90 MUL/DIV with immediate addressing

2020-11-18 [1.42 Bld 180]

- Addition    : Support Toshiba TLCS-870/C as target
- Bugfix      : do not search relative to current file's path if (B)INCLUDEd
                file's path is absolute

2020-11-08 [1.42 Bld 179]

- Bugfix      : MCS-48: correctly regard forward references when checking
                memory bank of CALL/JMP target

2020-11-04 [1.42 Bld 178]

- Addition    : Add DW and DB as aliases for BYT/ADR for 68xx targets
- Addition    : Add MB assume value for MCS-48
- Bugfix      : fix -r option on p2bin and p2hex

2020-10-25 [1.42 Bld 177]

- Addition    : Add some 68xx instruction aliases used on other assemblers
- Addition    : new target: KENBAK

2020-10-19 [1.42 Bld 176]

- Addition    : bit symbols for H8/300 and H8/500
- Addition    : support half size (16 bit) floating point type

2020-10-02 [1.42 Bld 175]

- Addition    : register symbols for TLCS-9000
- Addition    : -relaxed command line switch to enable RELAXED mode
                by default
- Addition    : For H8/500, allow H'... syntax for hex constants in
                relaxed mode
- Addition    : For H8/500, bit operations by default assume word size
                if destination is a register
- Addition    : For H8/500, allow :8 and :16 size specifiers on immediate
                source operand for MOV and CMP
- Addition    : For H8/500, allow DATA as an alias for DC

2020-09-19 [1.42 Bld 174]

- Change      : rework register symbol handling
- Addition    : register symbols for 68K, M16, M16C, H8/300, H8/500,
                SH7x00, XGATE, H16, i960, XA, and 29K

2020-08-25 [1.42 Bld 173]

- Change      : avoid error/warning number of zero
- Addition    : allow operand size attributes for SET and EQU

2020-06-22 [1.42 Bld 172]

- Addition    : add column to MAP file declaring whether symbol is constant
                or variable
- Bugfix      : Z8: do not allow odd indirect register pairs
- Bugfix      : differentiate CMOS/NMOS Z8 variants, remove Z8604 due to lack of documentation
- Bugfix      : Super8: Allow arguments with bit 3 set for SRP0/SRP1
- Bugfix      : Super8: correct CALL IA encoding
- Bugfix      : Super8: Only allow even register addresses for MULT/DIV/LDW/DECW/INCW on Super8/Z8
- Change      : Super8: rename devices to Z88C00 and Z88C01
- Bugfix      : Z8/Super8: correct 8-bit-displacements to be signed
- Addition    : allow argument 1/2/4 to RTWP on TMS99105/99110

2020-06-13 [1.42 Bld 171]

- Addition    : add option to operate AVR target with byte-structured
                code segment

2020-06-08 [1.42 Bld 170]

- Bugfix      : catch segfault when being called with non-existent
                file

2020-05-27 [1.42 Bld 169]

- Addition    : new built-in function DEFINED() to test whether
                a symbol is defined
- Change      : remove strict distinction between strings and
                multi-character constants
- Bugfix      : do not allow CMPI with PC-relative destination
                up to 68010.
- Bugfix      : 68K: forbid usage of An with byte size in a few
                instructions

2020-05-18 [1.42 Bld 168]

- Bugfix      : avoid spurious occurences of 'pointer size passed to as_vsnprcatf' message
- Bugfix      : fix 6301 BSET/BCLR instructions

2020-05-17 [1.42 Bld 167]

- Bugfix      : do not allow BRN on 6800
- Addition    : add 6801 as target

2020-05-15 [1.42 Bld 166]

- Bugfix      : add HALT instruction for 8080/8085 in Z80 syntax mode
- Addition    : implement 8085(UNDOC) instructions also in Z80 syntax
- Addition    : provide exclusive Z80 syntax mode

2020-05-03 [1.42 Bld 165]

- Addition    : Add Philips (MAB)84X1

2020-04-26 [1.42 Bld 164]

- Bugfix      : correct encoding of 65816 MVP/MVN instructions
- Addition    : Add DN instruction to dispose nibbles (because I can...)
- Addition    : Support DB/DW/DD/DQ/DT instructions for Atmel AVR
- Addition    : Add EEDATA segment for Atmel AVR and PIC16C8x
- Addition    : Extend P2BIN & P2HEX to allow data conversion from
                other segments than CODE

2020-04-12 [1.42 Bld 163]

- Change      : make codepage/character set handling more flexible

2020-04-05 [1.42 Bld 162]

- Change      : rework remaining include files to English comments
- Bugfix      : correct 4004 RnP register pair syntax

2020-04-04 [1.42 Bld 161]

- Addition    : Allow numeric condition argument to JCN on 4004
- Addition    : Allow alternate register pair syntax for 4004
- Change      : rework more include files to English comments

2020-04-02 [1.42 Bld 160]

- Bugfix      : change handling of 65816 BRK instruction, similar to 6502
- Bugfix      : correct PER instruction on 65816
- Change      : start reworking include files to English comments

2020-03-29 [1.42 Bld 159]

- Change      : change the strategy PADDING uses

2020-03-21 [1.42 Bld 158]

- Addition    : Provide register definitions for a couple of
                Z8 Encore targets
- Addition    : Provide bit object support for Z8 Encore
- Change      : allow more 8-bit characters in macro parameter names

2020-03-04 [1.42 Bld 157]

- Addition    : Add Zilog Super8 as target

2020-02-19 [1.42 Bld 156]

- Change      : rework build system to allow cross-builds

2020-01-31 [1.42 Bld 155]

- Addition    : Add TI990/12
- Bugfix      : 68xxx RESET instruction should be privileged
- Bugfix      : ANDI/ORI with CCR should be available on 68008 as well

2020-01-24 [1.42 Bld 154]

- Addition    : differentiate TMS9900 and Model 990 computer regarding
                privileged mode, add TMS9995, TMS99105 and TMS9940

2020-01-12 [1.42 Bld 153]

- Bugfix      : Corrections for 6309 PC-relative addressing
                when opcode is longer than one byte
- Change      : change handling of 6502 BRK instruction
- Bugfix      : allow some more addressing modes for 6309

2020-01-06 [1.42 Bld 152]

- Bugfix      : eliminate redundant error messages on 6502
- Change/Fix  : rework handling of listing macro expansion modifiers
- Bugfix      : correct operand order for shift instructions on MIL STD 1750
- Bugfix      : escape again spaces in MAP file output
- Bugfix      : handle case of empty label with : marker

2019-12-07 [1.42 Bld 151]

- Addition    : Add MN161x as target (contribution by Haruo Asano)
- Addition    : allow explicit address size specification on BBC/BBR/RMB/SMB for 65C02++
- Bugfix      : LDA (nn) was accidentally allowed for 6502
- Bugfix      : Change addressing mode from (nnnn) to (nn) for HuC6280
- Addition    : Add more devices and bit symbols for ST6

2019-09-25 [1.42 Bld 150]

- Addition    : Add a couple of ST7 types

2019-09-15 [1.42 Bld 149]

- Bugfix      : built-in function abs() works again
- Change      : ORG to same address no longer starts a new record
                in output file
- Addition    : new command line switch '-listradix' to set number
                system in listing

2019-07-20 [1.42 Bld 148]

- Addition    : Add P2HEX output format "C arrays".
- Addition    : Add a couple of ST7/STM8 types

2019-06-09 [1.42 Bld 147]

- Addition    : Make include file search strategy more C-like:
                primarily search in the directory of the file
                that contains the INCLUDE statement, not the
                current directory the assembler was called from.
- Change      : Allow forward references in "\{...}" expressions
- Change      : Allow SET as both pseudo and machine instruction
                if it can be differentiated by argument count.
- Addition    : Add STM8 target

2019-04-20 [1.42 Bld 146]

- Addition    : Added J as generic relative jump for 78C1x
- Bugfix      : correct index underflow access on Z80 for some cases
- Bugfix      : Allow spaces between function name and argument(s)
- Bugfix      : Correct file closing/cleanup

2019-03-09 [1.42 Bld 145]

- Bugfix      : correct argument count check for STRUCT
- Addition    : Added Hitachi H16 target
- Addition    : allow displacement/address length override on TLCS-900
- Bugfix      : regard phase errors in data disposition instructions
- Addition    : add Commodore/CSG 65CE02 target

2019-02-15 [1.42 Bld 144]

- Bugfix      : correct/augment addressing modes for TLCS-900

2019-02-08 [1.42 Bld 143]

- Bugfix      : correct ColdFire MAC/EMAC syntax 

2019-02-02 [1.42 Bld 142]

- Addition    : Added Parallax SX20/28 target
- Bugfix      : Fix some errors regarding escaped characters in quoted sections
- Bugfix      : Allow index register scaling for Coldfire (again)
- Bugfix      : Better handling of forward-defined displacements on 68K/Coldfire

2019-01-03 [1.42 Bld 141]

- Addition    : Added Coldfire target MCF51QM

2018-12-21 [1.42 Bld 140]

- Addition    : support Fairchild F8
- Addition    : allow < and > modifiers on MCS-96 to force short resp.
                long address coding
- Addition    : allow < and > modifiers on C16x to force short resp.
                long coding
- Change      : remove limit of 20 instruction arguments

2018-11-26 [1.42 Bld 139]

- Bugfix      : allow word size for 68K move-to-CCR
- Change      : regard address space limit for short addressing on 68K
- Bugfix      : several fixes regarding forward references for 68K

2018-11-02 [1.42 Bld 138]

- Addition    : new command line swith -maxerrors to allow termination
                of assembly after a given number of errors.
- Addition    : new command line switch -Werror to treat warnings as
                errors
- Bugfix      : correct value range of 68K MOVEQ instruction
- Addition    : allow bit-addressable locations to be written in
                internal representation for 80C16x
- Addition    : reworked and extended ColdFire support

2018-09-04 [1.42 Bld 137]

- Change      : Huge internal reworks to allow reporting column of error

2018-08-06 [1.42 Bld 136]

- Addition    : allow nested use of PHASE and DEPHASE
- Addition    : allow some pseudo-ops and aliases for operators/phases for 53C8XX
- Bugfix      : fix assembly of 8086 OUT <imm>,AX/AL
- Bugfix      : fix assembly of 78K4 CALLF/CALLT/RETCS with !-marked argument
- Bugfix      : fix assembly of DSAREL() expressions on 53C8xx
- Bugfix      : fix specification of data register as 68K PMMU function code

2018-06-18 [1.42 Bld 135]

- Bugfix      : some instructions no longer worked on 68008
- Change      : P2HEX and P2BIN by default use auto-ranging

2018-05-06 [1.42 Bld 134]

- Addition    : add support NXP S12Z ("MagniV") family

2018-04-18 [1.42 Bld 133]

- Change      : ALIGN uses execution instead of load address as base
- Addition    : allow ALIGN to optionally fill padding area with
                byte pattern

2018-04-10 [1.42 Bld 132]

- Bugfix      : correct result of strstr() if search string is at end
                of string
- Bugfix      : correct month display on locale systems (off-by-one)
- Bugfix      : Also regard ' and " if enclosed in () or []

2018-03-29 [1.42 Bld 131]

- Bugfix      : correct date display on locale systems

2018-03-28 [1.42 Bld 130]

- Bugfix      : clean up date & time format handling for locale-based systems

2018-03-16 [1.42 Bld 129]

- Bugfix      : correct assumption of length of forward JSR/JMP on 68HC12

2018-03-11 [1.42 Bld 128]

- Bugfix      : correct distance range checking on SC/MP

2018-03-04 [1.42 Bld 127]

- Bugfix      : avoid 'target not on same page' for forward references
                on several platforms

2018-02-28 [1.42 Bld 126]

- Addition    : add AT43USB355

- Bugfix      : when writing line to .i file that contained a macro
                call and a label, only write out the label, plus an
                eventual comment.

2018-02-24 [1.42 Bld 125]

- Bugfix      : correct argument checking for CHARSET

- Bugfix      : If a line calling a macro contains a label not consumed
                by the macro, output the line (minus tha macro call)
                in the -P output

- Addition    : Optionally display column and position in source line
                for some errors
2018-01-21 [1.42 Bld 124]

- Addition    : add ATmega{8|16|32}U2,
                    ATmega{16|32}U4,
                    ATmega32U6,AT90USB646/647,AT90USB1286/1287

- Bugfix      : correct address space deduction for AVR

- Bugfix      : defining CPU aliases for AVR works again

2017-12-26 [1.42 Bld 123]

- Addition    : add ATtiny48/88/43u/441/841/828/1634/87/167/
                4/5/9/10/20/40/102/104/28/11/12/15/13A/24A/44A/
                84A, AT90S2323/2333/2343/8534

- Addition    : replace MACEXP with MACEXP_DFT/MACEXP_OVR

2017-11-27 [1.42 Bld 122]

- Bugfix      : correct double ASSR definition for ATmega8/16/32

- Bugfix      : correct UPE definition for ATmega162

- Bugfix      : correct SFR area size for ATmega1284RFR2

- Addition    : add a first batch of ATtiny variants

2017-11-21 [1.42 Bld 121]

- Bugfix      : correct behaviour of DATA for Atmel AVR

2017-11-20 [1.42 Bld 120]

- Addition    : add more ATmega variants

- Addition    : more flexible usage of ENUMs

- Addition    : if a statement was called with an incorrect number of
                arguments, the allowed range is printed as extended
                error message

- Addition    : if a statement or addressing mode is not supported on
                the selected CPU, the CPU variants supporting it are
                listed as extended error message

- Addition    : if an ENDM statement is missing, print which type of
                statement (macro defintion, REPT, IRP(C), WHILE) lacks
                an ENDM.

2017-08-21 [1.42 Bld 119]

- Addition    : add NEC 78K4

- Addition    : add Siemens SAB 80C382

- Addition    : add OKI MCS-48 variants

2017-07-30 [1.42 Bld 118]

- Bugfix      : correct several flaws in 68K address mode decoder

2017-06-28 [1.42 Bld 117]

- Bugfix      : correct MSP430 source operand conversion 0(Rn) -> @Rn

- Addition    : add HuC6280 target

- Addition    : add 65C19 target

- Addition    : allow IXH/IYH as alias for IXU/IYU on Z80UNDOC

- Addition    : allow SLS as alias for SLIA on Z80UNDOC

2017-06-03 [1.42 Bld 116]

- Addition    : add W65C02S target (proposed by Alessandro Gatti)

- Change      : implement MSP430 emulated instructions within assembler instead
                of with macros

- Addition    : add MSP430X instruction set

- Addition    : allow more fine-grained control of macro expansion in listing

- Bugfix      : allow searching PATH variables longer than 255 characters

- Bugfix      : use correct character on Windows platforms to concatenate
                AS_MSGPATH and message file name

2017-02-26 [1.42 Bld 115]

- Addition    : allow alternate syntax for SET and EQU

- Addition    : support the MICO8 prom_init hex format in P2HEX

- Bugfix      : handle the return value of fgets() and getcwd() at some places
                to silence compiler warnings

- Bugfix      : correct handling of SCAL instruction for 1805(A)

- Addition    : differentiate 1804/1805/1806 and 1804A/1805A/1806A instruction
                set

2016-11-01 [1.42 Bld 114]

- Addition    : add support for OKI OLMS-40

- Addition    : allow some alternate notations for 78C1x indirect addressing

- Addition    : add support for MIL STD 1750

- Addition    : allow Z80-style syntax for 8080/8085

- Addition    : add support for Hitachi HMCS400

2016-09-25 [1.42 Bld 113]

- Addition    : added bit definitions for 80C320 second UART

- Bugfix      : fix memory leak and incorrect format string on DPMI version

- Bugfix      : fix a couple of memory handling errors detected by valgrind

2016-09-11 [1.42 Bld 112]

- Addition    : add support for Toshiba TC9331

- Addition    : add support for TI TMS 320C4x

- Addition    : add include file with Hitachi/Renesas 6303 registers

2016-08-21 [1.42 Bld 111]

- Bugfix      : correct a couple of bugs detected by CLang

- Addition    : add support for NEC 78K3

2016-07-01 [1.42 Bld 110]

- Addition    : allow enforcement of prefixes for TLCS-9000

2016-06-26 [1.42 Bld 109]

- Bugfix      : Correct output file in respect to expanded structures

2016-04-26 [1.42 Bld 108]

- Bugfix      : For 8080/8085, complain about wrong register names
                for PUSH/POP

- Addition    : Allow automatic 16/32-bit deduction for inner
                displacement on 68K

- Addition    : Allow Intel-style hex syntax for addresses passed
                to P2BIN and P2HEX

2016-02-07 [1.42 Bld 107]

- Addition    : Allow register symbols on MCS-48/(2)51

2015-10-28 [1.42 Bld 106]

- Addition    : Allow sub-structures of same name in different structures

2015-10-23 [1.42 Bld 105]

- Bugfix      : Correct Handling of nested structures and unions
- Addition    : Allow unnamed structures and unions
- Bugfix      : Correct some SFR definitions for DS80C320
- Addition    : Allow ? as argument to BYT/FCB/ADR/FDB to reserve space

2015-10-17 [1.42 Bld 104]

- Bugfix      : Correct SHARED symbol output in C mode

- Bugfix      : Correct coding of CC on 6809 for push/pull

2015-09-26 [1.42 Bld 103]

- Bugfix      : On 8008, the assembler accidentally allowed
                INR, DCR and MOV with invalid register operands.

2015-08-30 [1.42 Bld 102]

- Bugfix      : yet another fix to correct handling of BSR
                on 68K

2015-08-19 [1.42 Bld 101]

- Bugfix      : correct PC-relative addressing on 807x target

- Bugfix      : add missing condition codes of 68K FPU

- Bugfix      : correct handling of 68K BSR instruction with
                8 bit displacement

2015-08-17 [1.42 Bld 100]

- Bugfix      : default integer constant mode for INS807x was
                Intel and not C as documented
- Bugfix      : various fixes & extensions for 807x target

2015-08-07 [1.42 Bld 99]

- Bugfix      : Correct handling of variadic macros
- Bugfix      : Suppress detection of 0x... as floating
                point constant on some platforms

2015-05-25 [1.42 Bld 98]

- Addition    : Add TMS1000 target

2014-12-20 [1.42 Bld 97]

- Bugfix      : repair -cpu command line option that was broken in previous build

2014-12-07 [1.42 Bld 96]

- Change      : rework/cleanup PIC, 1802, 3201x, 3202x, 3203x, 3206x, 3254x,
                4004, MELPS4500, 47Cxx, MCS-48/51, 56K, PowerPC, 65xx, 68xx, 68K targets

- Addition    : Add TLCS-870/C target

- Bugfix      : correct handling of TLCS-870 JR instruction without condition

2014-09-21 [1.42 Bld 95]

- Change      : flip order of changelog

- Change      : rework/cleanup 75K0, SH, 80C16x targets

- Addition    : allow keyword arguments and parameter defaults for macros

2014-08-31 [1.42 Bld 94]

- Bugfix      : for Z80 target, detect invalid condition identifiers

- Bugfix      : avoid infinite loop on M16 when chained addressing is used incorrectly

- Change      : rework/cleanup COP8, AVR, ACE, TMS9900, TLCS/9000, TLCS/900, i960,
                MCS-96, TLCS/90, 8X30x, TLCS/870, 8086, 8085, 78Kx, 78c10, uPD77230, uPD772x,
                65816/7700 targets, complete reworks and testcase on M16

- Bugfix      : BCLR/BSET/BSETI/BTST on M16 use format G/E/Q instead of G/E/R

- Bugfix      : do not allow JSR with direct mode on 6800

- Bugfix      : correct 8087 FIMUL coding

- Bugfix      : correct JSL/JML byte order for 65816

- Bugfix      : correct COP, PEI, PEA, BIT instructions for 65816

- Bugfix      : use correct bank register for 65816 JMP/JSR instruction

- Addition    : on 65816, allow DBR as alias for DT and PBR as alias for PG

2014-06-19 [1.42 Bld 93]

- Change      : put entry address into 01 record for Intel8 hex format

- Bugfix      : correct uninitialized array in M16 decoder

- Change      : for Z80, do not warn about possible short addressing for
                RL/RLC/RR/RRC A

- Change      - rework/cleanup Z80, F2MC8L, Picoblaze, H8/300, XA, M16C, STx
                targets, partially rework and provide initial test case for
                M16 target

2014-03-08 [1.42 Bld 92]

- Bugfix      : correct handling of escaped quotation marks when converting string
                to uppercase

- Addition    : add RORG statement

- Change      : for unresolved forwards, put forward statement position into extended error

- Addition    : added new function ASSUMEDVAL to query values set via ASSUME

2014-03-03 [1.42 Bld 91]

- Change      : allow register names R10...R15 for 4004/4040

- Addition    : add COP444 target

2013-12-21 [1.42 Bld 90]

- Bugfix      : IRPC messed up local symbol handling

- Bugfix      : correct handling of escaped quotes in string constants

- Change      : allow up to 64K code per line

2013-08-07 [1.42 Bld 89]

- Bugfix      : PADDING instruction available for 6805/6808

- Addition    : add COP440 target

- Bugfix      : better handling of overlong souce code lines

2013-03-22 [1.42 Bld 88]

- Addition    : support 75xx instruction set A & B

2013-03-09 [1.42 Bld 87]

- Bugfix      : correct PC-relative addressing on SC/MP

- Addition    : (NO)GLOBALSYMBOLS parameter for macros

- Addition    : add support for NEC uPD75xx

2012-12-31 [1.42 Bld 86]

- Change      : add Dx pseudo instructions to Signetics 2650

2012-12-09 [1.42 Bld 85]

- Change      : allow register symbols for Zilog Z8

2012-09-02 [1.42 Bld 84]

- Addition    : add support for XMOS XS1

- Addition    : optionally support UTF8 encoding

- Addition    : add Makefile definitions for OSX

2012-05-26 [1.42 Bld 83]

- Change      : implicit macro parameters are always case-insensitive

- Addition    : add REG instruction to MSP430

2012-01-21 [1.42 Bld 82]

- Addition    : added support for MPC 821 from Marcin Cieslak

- Bugfix      : regard symbol name expansion in arguments for SHARED

2011-10-20 [1.42 Bld 81]

- Change      : range checking of RP value for Z8 more graceful

2011-08-01 [1.42 Bld 80]

- Change      : rework (e)Z8 working register addressing

2010-12-12 [1.42 Bld 79]

- Bugfix      : correct back-transformation of SFR addresses to absolute for 80C167

- Bugfix      : allow arbitrary values for register pointer on eZ8

- Change      : split up Mico8 variants

2010-06-14 [1.42 Bld 78] 

- Bugfix      : do not optimize out 68K BSR if it has zero distance

2010-04-17 [1.42 Bld 77]

- Bugfix      : address problem of overlapping strcpy()

2010-04-11 [1.42 Bld 76]

- Bugfix      : correct operand checking for SHA/SHL on M16C

2010-03-26 [1.42 Bld 75]

- Bugfix      : correct address range for M16C bit short addressing

2010-03-14 [1.42 Bld 74]

- Addition    : DW/DD/DQ/DD, DC.[wlxsdp], ADR also accept string arguments

2010-02-27 [1.42 Bld 73]

- Bugfix      : corrected P2BIN checksum generation on Win32 systems
- Bugfix      : corrected macro nesting dispay in listing

2010-01-01 [1.42 Bld 72]

- Bugfix      : corrected address offset handling for H8/500
- Bugfix      : some coding corrections for Lattice Mico8

2009-07-25 [1.42 Bld 71]

- Bugfix      : corrected H8/500 register-to-register MOV coding

2009-06-07 [1.42 Bld 70]

- Addition    : added named temporary symbols

2009-05-10 [1.42 Bld 69]

- Bugfix      : allow more CPU aliases
- Addition    : dispay macro nesting in listing

2009-04-13 [1.42 Bld 68]

- Bugfix      : correct SC/MP relative addressing regarding page wrap

2009-04-10 [1.42 Bld 67]

- Bugfix      : correct AVR branch instructions when target is beyond 64K

2009-02-08 [1.42 Bld 66]

- Bugfix      : correct DINT coding for TMS7xxx

2008-11-23 [1.42 Bld 65]

- Addition    : allow Q for octal constants in Intel mode
- Bugfix      : correct coding of OUT instruction for 8008
- Change      : allow NUL characters in string symbols (again)

2008-10-25 [1.42 Bld 64]

- Addition    : added CHARFROMSTR function

2008-08-29 [1.42 Bld 63]

- Bugfix      : correct 68K TST addressing modes, PC-relative offsets for a few instructions

2008-08-22 [1.42 Bld 62]

- Bugfix      : correct MCS-96 DPTS/EPTS coding

2008-08-17 [1.42 Bld 61]

- Bugfix      : correct MCS-96 BMOVI coding

- Bugfix      : correct definition of PORTQS for MC68332

2008-08-10 [1.42 Bld 60]

- Bugfix      : allow 68xxx dynamic FMOVEM register list with lowercase-written data register

- Bugfix      : correct addressing mode list for FMOVEM register-to-memory

- Change      : allow 68K bit instructions with arguments ranging from 0..255 and issue
                warning for numbers beyond operand length

2008-06-22 [1.42 Bld 59]

- Addition    : add Atari Asteroids vector processor as target

- Bugfix      : disallow 68xxx byte-size ADDQ/SUBQ when using an address register

2008-03-31 [1.42 Bld 58]

- Bugfix      : correct 8086 CALLF/JMPF instructions

2007-12-31 [1.42 Bld 57]

- Bugfix      : correct SKINT -> SKNIT on 78C1x

- Bugfix      : correct LDN and RLDI instructions for 180x

- Change      : MSP decoder now works with hash table

- Addition    : add some MSP430 bit definitions

2007-09-24 [1.42 Bld 56]

- Bugfix      : correct handling of minus operator in nested expressions

2007-05-01 [1.42 Bld 55]

- Bugfix      : set correct default maximum nesting level

- Addition    : add BANKSEL pseudo instruction for PIC16C8x

- Addition    : add optional new integer syntax

2006-12-19 [1.42 Bld 54]

- Bugfix      : -t option allows full range of list mask

- Bugfix      : correct output of Intel16/Intel32 hex format for
                word-addressed targets

2006-12-17 [1.42 Bld 53]

- Bugfix      : corrected address space assignment of ATmega128

- Bugfix      : fixed negative assembly times on Win32

2006-12-09 [1.42 Bld 52]

- Bugfix      : added missing instructions for 78K2 target

- Bugfix      : corrected some instruction codings for 78K0

2006-08-26 [1.42 Bld 51]

- Addition    : finished 8008 target

2006-08-05 [1.42 Bld 50]

- Addition    : Add (68)RS08 (contribution by Andreas Bolsch)

- Bugfix      : For AVR, add the ATmega variant of the LPM instruction

- Addition    : Add AVR targets & address spaces up to ATmega256

- Bugfix      : correct parsing of indexed expressions for Z80 and TLCS-90(0)

2006-06-24 [1.42 Bld 49]

- Addition    : Add (68)HCS12 target

2006-05-08 [1.42 Bld 48]

- Bugfix      : add range checks to arguments on some COP41x instructions

- Addition    : Add COP42x target

2006-04-15 [1.42 Bld 47]

- Addition    : Add ${PREFIX} to installation script

2006-04-07 [1.42 Bld 46]

- Bugfix      : remove some warnings around paged address space of 68HC12X

- Addition    : Add COP4 target

2006-04-04 [1.42 Bld 45]

- Bugfix      : some corrections around paged address space of 68HC12X

2006-03-18 [1.42 Bld 44]

- Addition    : Add paged address space for 68HC12X

2005-12-17 [1.42 Bld 43]

- Bugfix      : XGDX instruction did not work on 6301

- Addition    : Add 2650 target

- Bugfix      : listing on 16-bit hosts lead to crashes

2005-11-04 [1.42 Bld 42]

- Addition    : warn about MSP430 code on odd addresses

- Bugfix      : .b as length specifier for 68K branch instructions would not work

- Bugfix      : correct address field of MOS hex format

- Bugfix      : correct DUP detection in Intel-style data disposition
                instructions

2005-10-02 [1.42 Bld 41]

- Bugfix      : correct endinaness for constant disposition on XGATE

- Bugfix      : correct endinaness for constant disposition of 8-bit Motorola ops
                on big-endian platforms

- Bugfix      : allow arbitrary register names for KCPSM3

- Bugfix      : correct register naming for KCPSM3

2005-09-17 [1.42 Bld 40]

- Bugfix      : correct 68HC12 behaviour for forward jump/call instructions

- Addition    : allow .w and .b as length specifier for 68K branch instructions

2005-09-12 [1.42 Bld 39]

- Addition    : add HC12X/XGATE instruction extensions

2005-09-08 [1.42 Bld 38]

- Bugfix      : correct Qxxn register decoding on TLCS-900

2005-08-07 [1.42 Bld 37]

- Bugfix      : correct mnemonic conflict for EXPORT on MICO8

- Addition    : allow instruction aliases for ...I variants on MICO8

2005-08-06 [1.42 Bld 36]

- Addition    : added LatticeMico8

2005-03-21 [1.42 Bld 35]

- Addition    : added ATM & LDWX instructions for Zilog eZ8

- Addition    : added KCPSM3 core

2004-11-20 [1.42 Bld 34]

- Bugfix      : allow double-memory addressing variants on TLCS/900 again

2004-09-26 [1.42 Bld 33]

- Bugfix      : correct operation of INHX... modes in P2HEX

- Bugfix      : setting of entry address in P2BIN did not work

- Bugfix      : fix crashes when programs defined more than 256
                bytes of code in one line

2004-05-29 [1.42 Bld 32]

- Bugfix      : correct erroneous detection of DUP operator inside
                string/character constants

2004-03-31 [1.42 Bld 31]

- Bugfix      : corrected 68HC11K4 instruction set, PRWINS command

2003-12-07 [1.42 Bld 30]

- Addition    : added NEC 78K2

2003-08-17 [1.42 Bld 29]

- Addition    : added 80C251T SFRs

- Addition    : added 80C167CS SFRs

- Addition    : added Zilog eZ8

2003-05-25 [1.42 Bld 28] 

- Addition    : added 4040 machine instructions

2003-03-30 [1.42 Bld 27]

- Addition    : integrated support for KCPSM/PicoBlaze provided by Andreas
                Wassatsch

- Addition    : added support for the INS807x processor family

- Bugfix      : allow source file specification in key file

2003-02-26 [1.42 Bld 26]

- Bugfix      : symbolic displacement with Atmel AVR did not work any more

2003-02-02 [1.42 Bld 25]

- Extension   : added EXPRTYPE function

- Bugfix      : in case-sensitive mode, IRP arguments were converted
                to uppercase

- Bugfix      : 4004 JCN instruction did not allow multiple conditions

- Extension   : allow line continuation

2002-11-23 [1.42 Bld 24]

- Extension   : added undocumented 8085 instructions

- Extension   : improved structure handling, added unions

- Extension   : DC allows ? as operand

2002-10-11 [1.42 Bld 23]

- Bugfix      : repaired named temporary symbols

2002-10-09 [1.42 Bld 22]

- Extension   : added nameless temporary symbols 

2002-05-25 [1.42 Bld 21]

- Extension   : added Atmel MEGA8/MEGA16 CPU types & registers

- Bugfix      : data disposal for Atmel did not work correctly

- Extension   : extended the 320C6x target with pseudo instructions and 
                machine instructions that previously had to be emulated
                with macros

- Extension   : ENDIF/ENDCASE show the line number of the IF/CASE statement
                they were matched to in the listing

- Bugfix      : [] as specifier for the root section was not accepted

- Bugfix      : avoid incorrect debug output when addresses of sections vary

2002-03-10 [1.42 Bld 20]

- Bugfix      : corrected line counting behaviour when REPT/IRP/WHILE draw
                contents not from file

- Extension   : more precise error messages for type conflicts in some places

2002-01-27 [1.42 Bld 19]

- Bugfix      : BIT-statements inside macros did not work correctly

- Bugfix      : WHILE-statement evaluates condition after last statement

2002-01-13 [1.42 Bld 18]

- Extension   : added INTLABEL option for macros

2001-11-04 [1.42 Bld 17]

- Extension   : added -gnuerrors command line option

- Extension   : added support for the TMS320C54x family from Texas Instruments

2001-08-11 [1.42 Bld 16]

- Bugfix      : do not allow line debug info in pseudo segments

- Bugfix      : more secure detection of ASCII integer constants

[1.42 Bld 15]

- Bugfix      : fixed extended register coding for TLCS-900

- Bugfix      : P2HEX: fix specification of entry address on command line

[1.42 Bld 14]

- Bugfix      : fixed crashes when HC16 cpu type was set from command line

[1.42 Bld 13]

- Bugfix      : in der Kommandozeile angegebene Symbole wurden immer in 
                Großbuchstaben umgewandelt

- Erweiterung : unterstützt 68HC11K4 windowing

- Bugfix      : pbind verfälschte sporadisch Daten beim Umkopieren

- Erweiterung : added avrlen parameter to p2hex

- Bugfix      : on DOS platforms, PLIST did not display 32-bit-addresses
                incorrectly

[1.42 Bld 11]

- Bugfix      : 6809-PUSH/PULL mit D-Register klappt jetzt wirklich (sorry!)

- Bugfix      : ACE: Segmente vereint, Bereiche/Startadressen korrigiert

[1.42 Bld 10]

- Erweiterung : NoICE-Symboltypenmaske setzbar

- Bugfix      : 6809-Stackoperation mit anderem Stackpointer funktionierten
                nicht

- Erweiterung : PUSH/PULL 6809 funktionieren auch mit Register D=A+B

- Bugfix      : 8048-ORL/ANL funktionieren wieder mit p1/p2

[1.42 Bld 9]

- Bugfix      : 680x0-Adressierungen korrigiert
                äußeres Displacement jetzt auch in Klammer schreibbar

[1.42 Bld 8]

- Erweiterung : DC.x / DS.x funktionieren auch für 68HC16

- Änderung    : Lizenz jetzt GPL

[1.42 Bld 7]

- Bugfix      : / als Parameterzeichen funktioniert wieder

[1.42 Bld 6]

- Bugfix      : Kodierungsfehler TLCS-900(MINC/MDEC, BS1B/BS1F) behoben

- Bugfix      : Abstürze bei BINCLUDE größerer Dateien unter DPMI behoben

[1.42 Bld 5]

- Bugfix      : REPT/IRP(C)/WHILE-Statement in IF-geklammerten Zweigen werden komplett
                übersprungen

- Bugfix      : Adressen NoICE-Debugfiles werden jetzt als Hex ausgegeben und auch so
                gekennzeichnet

- Erweiterung : die maximale Verschachtelungstiefe für Aufrufe eines Makros ist jetzt auf
                einen per NESTMAX einstellbaren Wert begrenzt

- Bugfix      : weitere Fixes in Bankregister-Parser TLCS-900

2000-05-29 [1.42 Bld 4]

- Erweiterung : Packing-Befehl für AVR eingeführt

- Erweiterung : ALLARGS/ARGCOUNT für Makros

- Bugfix      : Bankregister-Parser TLCS-900 repariert

- Erweiterung : temporäre Symbole

2000-03-13 [1.42 Bld 3]

- Bugfix      : 'ambiguous' Warnungen bei egcs beseitigt

- Bugfix      : EXG beim 680x0 korrigiert

- Aenderung   : Adressraum des 68HC08 ist jetzt 64K

2000-02-13 [1-42 Bld 2]

- Bugfix      : ADDX/SUBX beim 68000 waren vertauscht

2000-01-09 [1.42 Bld 1]

- Bugfix      : ADDX/SUBX beim 68000 funktionierten nicht

- Bugfix      : Im Listing und bei P2BIN/P2HEX/PBIND waren noch einige
                Formatstrings nicht plattformabhängig, was bei Werten über 
                32K merkwürdige Effekte ergab...

- Bugfix      : PC-relative Adressierung für 56300 benutzte falschen Offset

- Erweiterung : Längenoptionierung bei absoluter Adressierung im 56xxx
                läßt sich per '>' ausschalten

1999-09-15 [1.41r8 Bld 15]

- Erweiterung : Fairchild ACE als Prozessorziel

- Bugfix      : Probleme mit dem NULL-Device und dem NLS-Support einiger Linux-
                Distributionen behoben

- Erweiterung : REG-Statement fuer PowerPCs

- Bugfix      : Registerpaarsyntax fuer 4004 korrigiert

- Erweiterung : Minimalrecordlaenge fuer P2HEX

1999-07-06 [1.41r8 Bld 14]

- Erweiterung : Unterstützung der TMS320C20x-Befehlsuntermenge

- Erweiterung : hexadezimale Adressangaben für die Hilfsprogramm können jetzt
                auch in C-Notation gemacht werden

- Erweiterung : OUTRADIX-Befehl

- Änderung    : Syntax für 4004-Registerpaare ist jetzt R[02468ABCE]R[13579BDF]

- Erweiterung : Unterstützung Fujitsu F²MC8L

- Bugfix      : FMOVE <ea>,FPm funktionierte mit <ea> = D1 nicht (680x0)

- Bugfix      : FSMOVE und FDMOVE fuer 68040 fehlten noch

- Erweiterung : Kommandozeilenoption für P2HEX, um Minimalgröße S-Records zu
                setzen

- Bugfix      : -l - Option in P2HEX funktionierte nicht

1999-05-02 [1.41r8 Bld 13]

- Erweiterung : WRAPMODE-Befehl fuer Atmel AVR

- Änderung    : In Atmel-Debugfiles wird für jedes Wort eines Maschinenbefehls ein
                Record geschrieben, nicht mehr nur für das erste

1999-04-20 [1.41r8 Bld 12]

- Bugfix      : Parameterbereich B_RST für Ziel SC14xxx falsch

1999-04-09 [1.41r8 Bld 11]

- Erweiterung : Befehle / Register PPC403-MMU

- Erweiterung : National SC144xx-Support

- Bugfix      : Angabe von Symbol-Defines in der Kommandozeile, die nicht
                einfache Konstanten sind, konnten zu Abstürzen führen

- Erweiterung : Kommandozeilenoption, um CPU-Typ zu setzen

- Erweiterung : In der Kommandozeile kann ein Key-File referenziert werden

- Erweiterung : In der Kommandozeile kann die Zieldatei für Shared-Definitionen
                gesetzt werden

1999-02-08 [1.41r8 Bld 10]

- Bugfix      : Eine Reihe von Kodierungsfehlern im M16C-Teil beseitigt

1999-02-01 [1.41r8 Bld 9]

- Bugfix      : Weil einige Formatstrings nicht portabel waren, knallte
                es bisweilen unter DOS/DPMI

1999-01-27 [1.41r8 Bld 8]

- Bugfix      : Die implizite Erweiterung von Registern auf -paare klappte
                nicht auf allen Zielplattformen (680x0)

- Bugfix      : SBCD wurde falsch kodiert (680x0)

1999-01-17 [1.41r8 Bld 7]

- Erweiterung : Der 680x0-Teil legt die Länge äußerer Displacements jetzt
                selber fest.

1999-01-10 [1.41r8 Bld 6]

- Bugfix      : bei X/Y-Indizierung wurde im 65xx-Teil das Indexregister
                nicht sauber abgeprueft

- Erweiterung : SYM53C8xx-Unterstützung

- Erweiterung : i4004-Unterstützung

- Bugfix      : Der Adressbereich fuer die neueren 80C166-Derivate stand
                noch auf 0-3ffffh statt 0-ffffffh

- Bugfix      : Für PIC16C64/84 ist zusätzlich der Adreßbereich von $2000
                bis $2007 eingeschaltet. (oder ist das eine Erweiterung? 
                Ick wees nich...)

- Bugfix      : Wenn der vom einem Befehl erzeugte Code über eine Record-
                Grenze im P-File hinausging, gab es eine fehlerhafte Folge-
                adresse im neuen Record.

- Bugfix      : Wenn mit BINCLUDE Daten von mehr als 64K eingezogen wurden
                (strenggenommen, wenn BINCLUDE zur Anlage eines neuen
                Records in der P-Datei führte), gab es fehlerhafte Adressen
                im Record, außerdem fehlte die Prüfung auf Segmentgrenzen-
                überschreitung

1998-10-25 [1.41r8 Bld 5]

- Bugfix      : direkt indizierte Adressierung mit 16-Bit-Displacement
                ergab ein falsches Postbyte beim 68HC12

1998-10-18 [1.41r8 Bld 4]


- Erweiterung : NEC uPD77230-Unterstützung

- Erweiterung : BRANCHEXT fuer XA funktioniert jetzt auch für BR

- Erweiterung : Fehlermeldungen mit > > > am Anfang

- Bugfix      : TRAPA für H8/300H nachgetragen

- Bugfix      : LDD/STD mit <Reg>+<Symbol> klappte nicht

1998-09-24 [1.41r8 Bld 3]

- Bugfix      : Fuer MOV dir8,Rm im 80251-Teil wurde ein falscher Code erzeugt
                (Fehler im Manual!)

- Erweiterung : i960-Unterstuetzung

- Erweiterung : NEC uPD7720/25-Unterstützung

- Bugfix      : einige Kodierungsfehler im M16C-Teil behoben

1998-08-21 [1.41r8 Bld 2]

- Bugfix      : einige Bereichsmasken im Parser waren falsch gesetzt

- Erweiterung : Backslash-Ausdrücke in Character/String-Konstanten jetzt
                auch in hex oder oktal möglich

- Bugfix      : kurze 8051-Bitadressen wurden im 80251-Sourcemodus unnötig
                in lange Adressen umgewandelt.

- Aenderung   : nicht mit XA-PSW-Bits kollidierende 51er-Flags haben jetzt
                wieder die Originalnamen

- Bugfix      : Befehle mit genau 20 Argumenten gaben einen Crash

- Erweiterung : RADIX-Befehl zur Festlegung des Default-Zahlensystems

- Erweiterung : statt ELSEIF darf auch ELSE geschrieben werden

- Bugfix      : im Testprogramm T_FULL09 wurde an einigen Stellen ELSE statt
                ELSEIF benutzt

- Erweiterung : statt = darf auch == geschrieben werden

1998-07-02 [1.41r8 Bld 1]

- Erweiterung : String-Funktionen STRSUB und STRSTR

- Erweiterung : CODEPAGE-Anweisung

- Bugfix      : Manual-Pages machten Probleme mit catman unter Solaris

- Bugfix      : Zeilen, die nur aus Label bzw. Kommentar bestanden, wurden
                nicht in den Makroprozessoroutput übernommen

- Bugfix      : DEFINEs arbeiteten nicht korrekt

- Erweiterung : neue Argumentvarianten für CHARSET

[1.41r7 Bld 20]

- Bugfix      : DD und DQ legten Daten immer in Little-Endian ab, egal
                von der Einstellung mit BIGENDIAN

1998-06-02 [1.41r7 Bld 19]

- Bugfix      : TST ab 68020 funktionierte nicht mit immediate/PC-relativ

- Bugfix      : Adressierungsart ([pc]) funktionierte im 68K-Teil nicht

- Bugfix      : MTCRF im PowerPC-Teil war nicht korrekt implementiert

- Bugfix      : DATA im AVR-Teil verschlampte letztes Argument (nur C-Version)

- Bugfix      : In STDDEF60.INC waren einige PPC403-Register falsch definiert

- Bugfix      : MOVE vom/zum CCR war als Byte-Operation kodiert

1998-05-25 [1.41r7 Bld 18]

- Bugfix      : TST ab 68020 funktionierte nicht mit Adreßregister

[1.41r7 Bld 17]

- Bugfix      : Ungültige Bitadressen erzeugten z.T. beim 80C16x keine
                Fehlermeldungen

- Erweiterung : Registersymbole auch für 80C16x

1998-04-13 [1.41r7 Bld 16]

- Bugfix      : EQU/SET akzeptierten kein leeres Argument, um typenlose Symbole
                zu definieren

- Bugfix      : LDD/STD beim AVR kamen nicht mit symbolischen Offsets zurecht

- Erweiterung : 320C6x-Support

1998-02-16 [1.41r7 Bld 15]

- Bugfix      : BINCLUDE, die zweite...

1998-01-26 [1.41r7 Bld 14]

- Erweiterung : Die Pseudo-Befehle BYT/FCB,ADR/FDB und FCC erlauben jetzt auch
                den von DC.x her bekannten Wiederholungsfaktor.

- Bugfix      : MOVC beim 8051 gab keine Fehlermeldung bei einem ungueltigen
                zweiten Parameter aus.

1998-01-12 [1.41r7 Bld 13]

- Bugfix      : in REG166.INC war das CAPREL-Register fuer einige 80C16x-
                Varianten falsch beschrieben

- Bugfix      : EXTP legte fuer 80C16x die Bits in einer falschen Reihenfolge
                ab.

1997-12-03 [1.41r7 Bld 12]

- Bugfix      : BINCLUDE arbeitete nicht korrekt, wenn nur der Offset 
                angegeben war

1997-11-20 [1.41r7 Bld 11]

- Bugfix      : MOVBZ/MOVBS funktionierten in der Kombination 'rn,abs'
                nicht

1997-11-17 [1.41r7 Bld 10]

- Erweiterung : 68K-Teil kennt Motorola ColdFire

1997-10-27 [1.41r7 Bld 9]

- Erweiterung : P2BIN und P2HEX koennen jetzt optional die Quelldateien nach
                Umwandlung loeschen

- Erweiterung : P2BIN kann jetzt dem Image die Startadresse voranstellen

- Erweiterung : Unterstuetzung der undokumentierten 6502-Befehle

1997-10-22 [1.41r7 Bld 8]

- Bugfix      : Eine Reihe von Kodierungen im 80C251-Teil waren noch verkehrt

1997-10-20 [1.41r7 Bld 7]

- Bugfix      : DUP spielte bei Argumenten <=0 verrueckt

- Erweiterung : STRLEN()-Funktion

- Erweiterung : Registersymbole fuer Atmel AVR

1997-10-09 [1.41r7 Bld 6]

- Bugfix      : CALL beim 80C166 ergab nicht immer korrekte Bedingungs-Codes

1997-09-29 [1.41r7 Bld 5]

- Bugfix      : Die Operandenreihenfolgen fuer Schiebe- und Immediate-Befehle
                beim TMS9900 waren nicht korrekt, und einfache Integerzahlen
                als Registerangaben waren nicht erlaubt.

- Erweiterung : Unterstuetzung der 68040-Steuerregister fuer MOVEC

1997-09-01 [1.41r7 Bld 4]

- Erweiterung : Unterstuetzung des Atmel HEX- und OBJ-Formates

1997-08-21 [1.41r7 Bld 3]

- Bugfix      : beim MELPS7700 wurden fuer DEC abs8 und ICN abs8 gleiche
                Opcodes erzeugt

1997-07-28 [1.41r7 Bld 2]

- Bugfix      : traten keine Fehler auf, so wurde eine alte Error-Log-Datei
                nicht beseitigt

- Erweiterung : Ueber die ARCHITECTURE-Variable kann jetzt die Zielplattform
                von AS abgefragt werden

- Aenderung   : PADDING ist nur noch fuer die 680x0-Familie defaultmaessig 
                eingeschaltet

1997-08-11 [1.41r7 Bld 1]

- Erweiterung : Definition von Strukturen ueber STRUCT/ENDSTRUCT

12.6.1997 [1.41r6 Bld 9]

- Bugfix      : Vorwaertsdeklarationen beim 68xx gaben noch Probleme bei
                Befehlen, die nur kurze absolute Adressen kennen

26.5.1997 [1.41r6 Bld 8]

- Erweiterung : Stack-Verbrauch im Parser reduziert (zu Gunsten der OS/2-
                Version)

- Erweiterung : < > >> als Praefixe fuer MELPS-7700 zugelassen

- Erweiterung : DB, DW... auch fuer MELPS-7700 zugelassen

9.6.1997 [1.41r6 Bld 7]

- Bugfix      : BTST akzeptierte kein ueberfluessiges .B Attribut

- Bugfix      : der AVR-Teil ist jetzt den offiziellen Typen angepasst

5.5.1997 [1.41r6 Bld 6]

- Erweiterung : Sektionsinfo in Debug-Meldungen

1.4.1997 [1.41r6 Bld 5]

- Erweiterung : Schreiben von Debug-Informationen moeglich

- Erweiterung : Includefiles fuer Siemens SAB C501/2/4

- Erweiterung : Includefile fuer 80C163/165 erweitert

24.3.1997 [1.41r6 Bld 4]

- Bugfix      : Die t-Option funktionierte verkehrtherum

- Bugfix      : bei grossen 8051-Programmen konnte es bei Vorwaersspruengen
                Fehler ueber zu lange Sprungdistanzen geben

- Bugfix      : Wenn beim 680x0 die Adressierungsart d16(An) eine Vor-
                waertsreferenz enthielt, gab es Fehler.

17.3.1997 [1.41r6 Bld 3]

- Erweiterung : neue Z8-Derivate

- Erweiterung : Beruecksichtigung der Maskenfehler des 80C504

13.3.1997 [1.41r6 Bld 2]

- Bugfix      : Bei grossen 8051-Programmen konnte es bei den Befehlen
                CJNE, DJNZ, JNB, JB und JBC zu out-of-branch-Fehlern
                kommen, obwohl das Ziel eigentlich innerhalb der Sprung-
                weite lag.

- Erweiterung : Zusaetzliche Prozessorfamilien: MCS-296, TMS9900

7.2.1997 [1.41r6 Bld 1]

- Bugfix      : Die BITPOS-Funktion arbeitete nicht korrekt.

- Aenderung   : Wird ein Makro in einem mit IF... ausgeschlossenen Teil
                referiert, so erfolgt die (MACRO)-Anzeige im Listing
                nicht mehr, als Zeichen, dass nicht expandiert wird.

- Bugfix      : Die meisten Include-Files arbeiteten im case-sensitiven
                Modus nicht korrekt.

- Bugfix      : Im TMS-370-Teil waren alle 16-Bit-Teile von Instruktionen
                verdreht (little statt big endian) abgelegt.

- Bugfix      : Im TMS-370-Teil wurde das #-Zeichen nicht immer akzeptiert.

- Bugfix      : Die DIVLU-Instruktion beim 166er war versehentlich als
                DIVUL abgelegt.

- Erweiterung : Zusaetzliche Prozessorfamilien: ST9, SC/MP und TMS7000

1997-01-21 [1.41r5 Bld 16]

- Bugfix      : wurde ein NEWPAGE-Befehl ohne Argument benutzt, kam
                bisweilen keine Reaktion

- Bugfix      : bei bitbedingten Sprungbefehlen des XA, die auf einer
                ungeraden Adresse mit vorangestelltem Label lagen, gab
                es Kodierungsfehler

- Bugfix      : wurden mit dem POPU-Befehl des XA gleichzeitig Register 
                aus der unteren und oberen Haelfte geholt, war die Reihen-
                folge der Einzelbefehle nicht spiegelbildlich zu PUSH/PUSHU

- Bugfix      : Der MUL-Befehl des 6805 wurde erst fuer den 68HC08 erlaubt

- Bugfix      : indizierte Adressierungsarten mit automatischem Inkrement/
                Dekrement erzeugten ein falsches Postbyte

1997-01-02 [1.41r5 Bld 15]

- Bugfix      : beim M16C war die Abfrage auf ungueltige Adressierungsmodi
                bei LDE/STE/INC/DEC/NOT/ROT/JMPS/ADJNZ nicht korrekt

- Bugfix      : beim MSP gab es keinen Abbruch bei ungueltiger Operandengroesse

- Bugfix      : beim MSP gab es keine Fehlermeldung wenn fuer BYTE ein
                Float-Argument verwendet wurde

- Bugfix      : beim MSP wurde das nicht erlaubte Attribut bei RETI nicht
                abgeprueft

- Erweiterung : PADDING geht jetzt auch beim MSP

- Bugfix      : die automatische Laengenumschaltung fuer relative Spruenge
                arbeitete beim H8/500 fehlerhaft

- Bugfix      : beim H8/500 gab es eine falsche Meldung bei absoluten
                Adressen ausserhalb der aktuellen Seite

- Bugfix      : beim 78C1x war der erlaube Displacement-Bereich in Adressen
                zu gross

- Bugfix      : Der SER-Befehl beim AVR erzeugte bisweilen keinen Code

- Bugfix      : Im 75K0-Teil wurden fuer Prozessoren >=75104 bisweilen
                keine Steuerregister akzeptiert

1996-12-19 [1.41r5 Bld 14]

- Bugfix      : beim H8/300(H): wurde bei Logikanweisungen mit einem C am Ende
                die Argumentzahl nicht kontrolliert

- Bugfix      : bei 32-bittiger Anzeige im Listing wurden keine Vornullen
                ausgegeben

- Bugfix      : die relativen Sprungbefehle beim TMS370 erlaubten nur Adressen von
                0..255 als Argument

- Bugfix      : beim MELPS4500 war versehentlich das DATA-Segment gesperrt

- Bugfix      : beim 16C8x war Konstantenablage im Codesegment nur 12-bittig
                zugelassen

- Bugfix      : bei einem REPT-Argument <1 erfolgte trotzdem ein Durchlauf

- Aenderung   : Fehlernummern fuer fatale Fehler wurden von Basis 2000 auf
                Basis 10000 geschoben

- Erweiterung : Konstantenablage ist jetzt auch im Codesegment zugelassen

1996-11-11 (alaaf...) [1.41r5 Bld 13]

- Bugfix      : bei MELPS7751 als Ziel funktionierten einige Befehle nicht

- Bugfix      : wurde beim Z8 ein ungueltiges Register fuer indizierte Adressierung angegeben,
                so gab es eine bloede Fehlermeldung

1996-11-05 [1.41r5 Bld 12]

- Erweiterung : DC.X funktioniert jetzt auch bei 68xx

- Bugfix      : wurde beim TLCS90 bei CALL, JMP oder RET eine ungueltige
                Bedingung benutzt, gab es keine Fehlermeldung

- Erweiterung : Funktionen TOLOWER, LOWSTRING

1996-10-28 [1.41r5 Bld 11]

- Bugfix      : Beim 6804 war die Bereichsabfrage nicht korrekt (16 statt 12 Bit)

- Bugfix      : Bei DC.x fuer den 68HC12 waren die Bytes paarweise verdreht

- Bugfix      : Mit READ in Makros eingelesene Symbole wurden als lokal zum Makro definiert

- Bugfix      : Beim 8086 gab es keine Fehlermeldung, wenn die schliessende Klammer (])
                eines Adressausdruckes fehlte

- Bugfix      : Beim 8086 wurde fuer Displacements von -128 versehentlich lange Adressierung
                benutzt

- Bugfix      : INS/EXT beim V30/35 erzeugten auch Code , wenn der Adressierungsmodus ungueltig
                war

- Bugfix      : wurde beim 8085  bei LDAX/STAX ein falsches Register benutzt, gab es eine unsinnige
                Fehlermeldung

- Bugfix      : Beim 8086 gab es bei falschem Adressierungsmodus in einigen Faellen doppelte 
                Fehlermeldungen

- Bugfix      : Beim PowerPC waren bei MTSPR/MFSPR/MTDCR/MFDCR die 5-Bit-Komponenten der Register-
                nummer verdreht

- Bugfix      : wurden beim 8086 8-Bit-immediate-Werte mit Vorwaertsreferenzen benutzt, so gab es
                in einigen Faellen Fehler wegen Bereichsueberschreitungen 

1996-10-14 [1.41r5 Bld 10]

- Bugfix      : wurde beim Wiederholungsfaktor von DC.x die schliessende 
                Klammer vergessen, so gab es unvorhersagbare Reaktionen 
                anstatt einer Fehlermeldung

- Bugfix      : die Attributabfrage bei PEA in 680x0-Teil war nicht korrekt

- Bugfix      : wurde beim 68xx ein inkorrektes Indexregister verwendet, so
                wurde kein Fehler gemeldet, sondern absolute Adressierung
                erzeugt

- Bugfix      : auf b endende Hex-Zahlen mit C-Syntax funktionierten im 
                RELAXED-Modus nicht

- Bugfix      : Prozessornamen COP87L48-->COP87L84 korrigiert

- Bugfix      : CBEQ beim 68HC08 erzeugte z.T. auch Code bei falschem 
                Adressierungsmodus

- Bugfix      : P2HEX/P2BIN arbeiteten nicht korrekt bei Adressen > 2GByte

- Erweiterung : zusaetzlicher BINCLUDE-Befehl

- Bugfix      : explizit kurze Adressen beim 6809 funktionierten nicht,
                wenn DPR<>0 war

- Erweiterung : BIGENDIAN nun auch beim PowerPC

1996-10-04 [1.41r5 Bld 9]

- Erweiterung : zusaetzlich 78K0 unterstuetzt

1996-09-23 [1.41r5 Bld 8]

- Bugfix      : im PowerPC-Teil gab es noch einige Big<->Little-Endian-
                Verdrehungen

1996-09-16 [1.41r5 Bld 7]

- Erweiterung : zusaetzlich MSP430 unterstuetzt

- Erweiterung : mit LISTING NOSKIPPED bzw. LISTING PURECODE kann man jetzt
                nicht assemblierte Teile aus dem Listing ausschliessen

1996-09-09 [1.41r5 Bld 6]

- Erweiterung : zum M16C gibt es jetzt auch ein Includefile

- Erweiterung : zusaetzlich COP8-Familie unterstuetzt

- Bugfix      : wurden im Zx80-Teil ADC oder SBC mit einer falschen 
                Operandenzahl benutzt, gab es eine falsche Fehlermeldung

- Bugfix      : wurden im Z380-Teil INA, INAW, OUTA, OUTAW mit einer Adresse 
                >2GByte benutzt, konnte es Kodierungsfehler geben

- Erweiterung : zusaetzliche Befehle zur bedingten Assemblierung: IFB und IFNB

- Erweiterung : neuer EXITM-Befehl, um eine Makroexpansion vorzeitig
                abzubrechen

- Bugfix      : in den englische Fehlermeldungen geisterten noch einige
                deutsche Woerter herum

1996-08-26 [1.41r5 Bld 5]

- Bugfix      : in PIC16C8x-Teil war die Adressbereichsbegrenzung nicht korrekt

- Erweiterung : zusaetzlich M16C-Familie unterstuetzt 

1996-08-19 [1.41r5 Bld 4]

- Bugfix      : Im 65xx-Teil funktionierten die Angaben < bzw. > zur Er-
                zwingung kurzer bzw. langer Adressen nicht korrekt

- Bugfix      : INC/INC A bzw. DEC/DEC A funktionierten beim MELPS/740 nicht

1996-08-12 [1.41r5 Bld 3]

- Bugfix      : Der TLCS-900-Teil machte bei der Bearbeitung von 2-Operanden-
                ALU-Befehlen (ADD,SUB,CMP...) auch weiter, wenn eine falschen
                Anzahl von Parametern angegeben war.

- Bugfix      : Im TLCS-900-Teil konnten bei der Benutzung vorwaertsreferen-
                zierter Symbole fuer Schiebeamplituden Fehler auftreten

- Erweiterung : Um etwas kompatibler zum AS11 von Motorola zu werden, gibt es
                jetzt im 68xx-Modus auch die Befehle FCC, FDB, FCB und RMB.

1996-08-05 [1.41r5 Bld 2]

- Bugfix      : noch 1,2 Kleinigkeiten im XA-Teil beseitigt...

1996-07-15 [1.41r5 Bld 1]

- Bugfix      : lag beim XA ein Normier-/Schiebebefehl mit 32-Bit-Operanden-
                laenge auf einer ungeraden Adresse, so dass bei vorangestelltem 
                Label ein NOP eingeflickt werden musste, so wurde ein falscher 
                Code erzeugt.

- Bugfix      : Im TLCS-900-Teil wurde ein Byte zu frueh auf laengere 
                Displacements beim Adressierungsmodus (reg+disp) umgeschaltet.

1996-06-10 [1.41r4 Bld 10]

- Bugfix      : bei P2HEX war die Bereichsueberpruefung fuer den 
                Datenadressbereich des DSK-Formats fehlerhaft

- Bugfix      : einige Abfragen auf I/O-Fehler bei P2HEX und P2BIN fehlten

- Bugfix      : der SFRB-Befehl gab einen falschen Wert im Listing aus

- Bugfix      : BIGENDIAN funktionierte nicht fuer die ganze 8051-Familie,
                sondern nur fuer den 80C251

- Bugfix      : Bei 16-Bit-immediate-Werten im 8051-Modus war die 
                Bereichsabfrage nicht korrekt

- Bugfix      : Wurde im 8051-Modus bei registerindirekter Adressierung ein
                fehlerhafter Registername angegeben, gab es keine Fehlermeldung

- Bugfix      : im 8051-Teil war die Benutzung von immediate-Operanden bei PUSH
                nicht auf den 80C251 eingeschraenkt

- Bugfix      : PUSH/POP DRk beim 80251 erzeugte fehlerhafte Codes

- Bugfix      : bei 8051:ACALL/AJMP/ECALL/EJMP waren negative Adressen erlaubt

- Bugfix      : im 80251-Modus war JG undefiniert, dafuer lieferte JSLE einen
                falschen Opcode

- Bugfix      : bei 80251: JMP wurden fuer sehr grosse Distanzen SJMPS erzeugt

- Bugfix      : der MCS-51-DJNZ-Befehl gab fuer Distanzueberschreitungen eine
                ungenaue Fehlermeldung aus

- Erweiterung : ueber die HAS64-Variable kann man jetzt abfragen, ob der
                Parser mit 64 Bit arbeitet

- Erweiterung : DQ kann jetzt auch 64-Bit-Integers ablegen

1996-05-31 [1.41r4 Bld 9]

- Bugfix      : Im MELPS-7700-Teil funktionierten eine Reihe von Befehlen nicht mehr,
                wenn man den 7751er als Ziel-CPU einstellte.

- Bugfix      : Der SEL-Befehl des MCS-48-Teils gab bei einer falschen 
                Parameterzahl eine falsche Fehlermeldung aus.

1996-05-29 [1.41r4 Bld 8]

- Bugfix      : Der 68000-Teil schrieb Bloedsinn in die Code-Datei, wenn in 
                einer Zeile genau ein Byte Code erzeugt wurde.

1996-05-28 [1.41r4 Bld 7]

- Bugfix      : Der Z80-Teil hatte bei IX/IY-Displacements ein Byte zu frueh 
                auf laengere Offsets umgeschaltet.

- Bugfix      : Die \i und \h - Escapes funktionierten in Strings nicht.

- Bugfix      : Die Bereichseingrenzung fuer 24-Bit-Zahlen war nicht korrekt.

1996-05-13 [1.41r4 Bld 6]

- Erweiterung : MELPS-7700-Teil kennt jetzt auch die 7751er-Befehlssatzer-
                weiterungen.

- Bugfix      : einige haarstraeubende Nichtinitialisierungen von Variablen 
                beseitigt, die in Zusammenhang mit der Definition von Symbolen 
                in der Kommandozeile auftreten koennen.

1996-05-06 [1.41r4 Bld 5]

- Bugfix      : VERSION-Variable stand noch auf 1.41r2

1996-04-09 [1.41r4 Bld 4]

- Erweiterung : MELPS-7700-Teil kennt jetzt auch die 7750er-Befehlssatzer-
                weiterungen

1996-03-25 [1.41r4 Bld 3]

- Bugfix      : Erwaehnung der -quiet sowie -alias -Optionen fehlte in der
                Online-Hilfe
- Erweiterung : 80C517 als Prozessortyp aufgenommen (+Register in STDDEF51.INC)

1996-03-18 [1.41r4 Bld 2]

- Bugfix      : Kodierungsfehler im Z(3)80-Teil behoben:
                - MTEST
                - LD (IX/IY+n),r16
                - MULTW/MULTUW/DIVUW [HL,]IX/IY/imm16
                - LD r16,BC
- Bugfix      : Fehlermeldungen ueber fehlende/fehlerhafte Key-Datei kamen
                in der englischen Version noch auf Deutsch.

1996-03-11 [1.41r4 Bld 1]

- Bugfix      : -l - Option funktionierte bei P2HEX nicht.
- Erweiterung : P2HEX/P2BIN koennen Dateiinhalte auf andere Adressen
                verschieben.
- Erweiterung : P2HEX kann den Einsprungpunkt auch in Intel-Hex-Files
                weitergeben.
- Erweiterung : Kommentare in SHARED-Anweisungen werden in die Share-Datei
                weitergegeben.
- Aenderung   : Als Kommentarzeichen wird fuer Share-Dateien im Pascal-Modus
                (* ... *) anstelle { ... } verwendet.  Dies erlaubt es, 
                die Dateien auch fuer Modula zu verwenden und sollte fuer
                Pascal keine Nachteile mit sich bringen.  
